#include <iostream>
#include "functions.h"
#include <gtest/gtest.h>
#include <list>
#include <deque>

int main() {
  std::cout << "Do you want to run tests?[yes/no]: ";
  std::string mode;
  std::cin >> mode;
  std::transform(mode.begin(), mode.end(), mode.begin(),
                 [](unsigned char c) { return std::tolower(c); });

  if (mode == "yes") {
    testing::InitGoogleTest();
    RUN_ALL_TESTS();
  } else {
    std::string filename = "data.txt";
    CreateDataStream(filename);
    auto result1 = LoadDataStream<std::list<int>>(filename);
    auto result2 = LoadDataCopy<std::deque<int>>(filename);
    auto result3 = LoadDataStream<std::vector<int>>(filename);
    auto result4 = LoadDataCopy<std::deque<int>>(filename);

    ModifyTemplate(result1);
    ModifyIter(result2.begin(), result2.end());
    ModifyForEach(result3);
    ModifyTransform("data.txt", "data4.txt");
    OutputResultCopy("data1.txt", result1);
    OutputResultStream("data2.txt", result2);
    OutputResultCopy("data3.txt", result3);
  }
}

