#include "functions.h"

void CreateDataStream(const std::string &fileName) {
  std::ofstream outFile(fileName, std::ofstream::out);
  std::random_device rd;
  std::mt19937 mt(rd());
  std::uniform_int_distribution<int> dist(-50, 50);
  for (size_t i = 0; i < 99; ++i) {
    outFile << dist(mt) << '\t';
  }
  outFile << dist(mt) << std::endl;
  outFile.close();
}

void CreateDataGenerate(const std::string &fileName) {
  std::ofstream outFile(fileName, std::ofstream::out);
  std::random_device rd;
  std::mt19937 mt(rd());
  std::uniform_int_distribution<int> dist(-50, 50);
  std::vector<int> buffer(100);
  std::generate(buffer.begin(), buffer.end(), [&dist, &mt]() { return dist(mt); });
  std::ostream_iterator<int> fileIterator(outFile, "\t");
  std::copy(buffer.begin(), buffer.end() - 1, fileIterator);
  outFile << *(buffer.end() - 1) << std::endl;
  outFile.close();
}

void ModifyTransform(const std::string &inputFileName, const std::string &OutputFileName)  {
  std::ifstream fileInputStream(inputFileName);
  std::ofstream fileOutputStream(OutputFileName, std::ios::out);

  auto firstNegativeIter = std::find_if(std::istream_iterator<int>(fileInputStream),
                                        std::istream_iterator<int>(),
                                        [](int elem) { return elem < 0; });
  fileInputStream.clear();
  fileInputStream.seekg(0);

  int firstNegative = *firstNegativeIter;
  std::transform(std::istream_iterator<int>(fileInputStream),
                 std::istream_iterator<int>(),
                 std::ostream_iterator<int>(fileOutputStream, "\t"),
                 [firstNegative](const int &elem) {
                   if (elem % 2 == 0) {
                     return elem * firstNegative;
                   } else {
                     return elem;
                   }
                 });
  fileOutputStream << std::endl;
}