#include "gtest/gtest.h"
#include "functions.h"

#include <vector>
#include <deque>
#include <list>

TEST(Creation, CreateDataStreamTest) {
  const std::string filename = "../test_files/test1.txt";
  CreateDataStream(filename);
  auto result1 = LoadDataStream<std::vector<int>>(filename);
  auto result2 = LoadDataCopy<std::vector<int>>(filename);
  ASSERT_EQ(result1 == result2, true);
}

TEST(Creation, CreateDataGenerateTest) {
  const std::string filename = "../test_files/test2.txt";
  CreateDataGenerate(filename);
  auto result1 = LoadDataStream<std::list<int>>(filename);
  auto result2 = LoadDataCopy<std::deque<int>>(filename);
  ASSERT_EQ(true, std::equal(result1.begin(), result1.end(), result2.begin()));
}