#include "gtest/gtest.h"
#include "functions.h"

#include <vector>
#include <deque>
#include <list>

TEST(Modify, FirstTest) {
  const std::string filename = "../test_files/test3.txt";
  CreateDataStream(filename);
  auto result1 = LoadDataStream<std::vector<int>>(filename);
  auto result2 = LoadDataCopy<std::vector<int>>(filename);
  ASSERT_EQ(result1 == result2, true);

  ModifyForEach(result1);
  ModifyIter(result2.begin(), result2.end());

  ASSERT_EQ(result1 == result2, true);
}

TEST(Modify, SecondTest) {
  const std::string filename = "../test_files/test4.txt";
  CreateDataGenerate(filename);
  auto result1 = LoadDataStream<std::list<int>>(filename);
  auto result2 = LoadDataCopy<std::deque<int>>(filename);
  ASSERT_EQ(true, std::equal(result1.begin(), result1.end(), result2.begin()));

  ModifyIter(result1.begin(), result1.end());
  ModifyTransform("../test_files/test4.txt", "../test_files/test5.txt");
  auto result3 = LoadDataCopy<std::deque<int>>("../test_files/test5.txt");
  ASSERT_EQ(true, std::equal(result1.begin(), result1.end(), result3.begin()));
}