#pragma once
#include "person.h"
#include <map>
#include <fstream>
#include <iomanip>
#include <algorithm>


class DBPerson {
 public:
  DBPerson(const std::string &filename);
  void Open();
  void LoadData();
  void AppendDataToFile(const std::vector<Person> &listOfPersons);
  void RemoveDataFromFile(int id);
  void ReplaceDataInFile(int id, const Person& newPerson);
  void SerializeText();
  void SelectByDepartmentNumber(const std::string &savefilename, int departmentNumber);
  void SelectByGender(const std::string &savefilename, bool gender);
  void SelectByDateStart(const std::string &savefilename, int dayStart, int monthStart, int yearStart);
 private:
  std::string filename;
  bool isOpen;
  std::map<int, Person> dataTable;
};