#include "db_person.h"

void PrintCommandList() {
  std::cout << "Command list:\n"
            << "0 - exit program\n"
            << "1 - appendData\n"
            << "2 - removeData\n"
            << "3 - replaceData\n"
            << "4 - text serialize\n"
            << "5 - selectors\n"
            << "6 - help\n";
}

void PrintSelectors() {
  std::cout << "Command list:\n"
            << "1 - select by department number\n"
            << "2 - select by gender\n"
            << "3 - select by dateStart\n";
}

int main() {

  std::cout << "Input db path: ";
  std::string dbName;
  std::cin >> dbName;
  DBPerson db(dbName);
  db.Open();
  int option;
  PrintCommandList();
  std::cin >> option;
  while (option != 0) {
    switch (option) {
      case 1: {
        std::vector<Person> persons{};
        Person currentPerson{};

        while (true) {
          std::cout << "Person:\n";
          std::cin >> currentPerson;
          std::cout << "0 - End input\n"
                    << "1 - Add more persons\n";
          int result;
          persons.push_back(currentPerson);
          std::cin >> result;
          if (result == 0) {
            break;
          }
        }
        db.AppendDataToFile(persons);
        break;
      }

      case 2: {
        int id;
        std::cout << "Input index:\n";
        std::cin >> id;
        db.RemoveDataFromFile(id);
        break;
      }

      case 3: {
        int id;
        std::cout << "Input index:\n";
        std::cin >> id;
        std::cout << "Input new person:\n";
        Person current{};
        std::cin >> current;
        db.ReplaceDataInFile(id, current);
        break;
      }

      case 4: {
        db.SerializeText();
        break;
      }

      case 5: {
        PrintSelectors();
        std::cout << "Input command:\n";
        int selectType;
        std::cin >> selectType;
        std::string dumpfile;
        std::cout << "Output file for selector:\n";
        std::cin >> dumpfile;
        switch (selectType) {
          case 1: {
            int num;
            std::cout << "Input department number:\n";
            std::cin >> num;
            db.SelectByDepartmentNumber(dumpfile, num);
            break;
          }

          case 2: {
            bool num;
            std::cout << "Input gender:\n";
            std::cin >> num;
            db.SelectByGender(dumpfile, num);
            break;
          }

          case 3: {
            int day, month, year;
            std::cout << "Input date:\n";
            std::cin >> day >> month >> year;
            db.SelectByDateStart(dumpfile, day, month, year);
            break;
          }

          default: {
            std::cout << "Unknown selector\n";
          }
        }
        break;
      }

      case 6: {
        PrintCommandList();
        break;
      }

      default: {
        std::cout << "Unknown command\n";
        break;
      }
    }

    std::cout << "Input option:\n";
    std::cin >> option;
  }
  getchar();
  return 0;
}
