#include "person.h"

std::istream &operator>>(std::istream &in, Person &person) {
  in >> person.personNumber
     >> person.departmentNumber
     >> person.name
     >> person.surname
     >> person.patronymic
     >> person.salary
     >> person.dayStart
     >> person.monthStart
     >> person.yearStart
     >> person.premiumPercent
     >> person.tax
     >> person.workDaysCount
     >> person.workDaysCountDone
     >> person.received
     >> person.withheld
     >> person.gender;

  return in;
}
std::ostream &operator<<(std::ostream &out, const Person &person) {
  out << person.personNumber
      << person.departmentNumber
      << person.name
      << person.surname
      << person.patronymic
      << person.salary
      << person.dayStart
      << person.monthStart
      << person.yearStart
      << person.premiumPercent
      << person.tax
      << person.workDaysCount
      << person.workDaysCountDone
      << person.received
      << person.withheld
      << person.gender;

  return out;
}
Person::Person(const Person &anotherPerson)
    : personNumber(anotherPerson.personNumber),
      departmentNumber(anotherPerson.departmentNumber),
      salary(anotherPerson.salary),
      dayStart(anotherPerson.dayStart),
      monthStart(anotherPerson.monthStart),
      yearStart(anotherPerson.yearStart),
      premiumPercent(anotherPerson.premiumPercent),
      tax(anotherPerson.tax),
      workDaysCountDone(anotherPerson.workDaysCountDone),
      workDaysCount(anotherPerson.workDaysCount),
      received(anotherPerson.received),
      withheld(anotherPerson.withheld),
      gender(anotherPerson.gender) {

  strcpy_s(name , anotherPerson.name);
  strcpy_s(surname , anotherPerson.surname);
  strcpy_s(patronymic , anotherPerson.patronymic);
}
Person &Person::operator=(const Person& anotherPerson) {
  if (this == &anotherPerson) {
    return *this;
  }

  personNumber = anotherPerson.personNumber;
  departmentNumber = anotherPerson.departmentNumber;
  strcpy_s(name , anotherPerson.name);
  strcpy_s(surname , anotherPerson.surname);
  strcpy_s(patronymic , anotherPerson.patronymic);
  salary = anotherPerson.salary;
  dayStart = anotherPerson.dayStart;
  monthStart = anotherPerson.monthStart;
  yearStart = anotherPerson.yearStart;
  premiumPercent = anotherPerson.premiumPercent;
  tax = anotherPerson.tax;
  workDaysCountDone = anotherPerson.workDaysCountDone;
  workDaysCount = anotherPerson.workDaysCount;
  received = anotherPerson.received;
  withheld = anotherPerson.withheld;
  gender = anotherPerson.gender;

  return *this;
}
